---
{% if inventory_hostname != groups[kubernetes_rke2_control_group][0] %}
server: https://{{ kubernetes_main_address }}:9345
{% endif %}
token: {{ hostvars[groups[kubernetes_rke2_control_group][0]].token }}
node-name: {{ inventory_hostname }}
{% if kubernetes_rke2_enable_hardening %}
{% if kubernetes_version is defined and kubernetes_version is version('1.29', '>=') %}
profile: cis
{% elif kubernetes_version is defined and kubernetes_version is version('1.25', '>=') %}
profile: cis-1.23
{% else %}
profile: cis-1.6
{% endif %}
protect-kernel-defaults: true
selinux: true
write-kubeconfig-mode: "0600"
{% endif %}
{% if (kubernetes_rke2_cni is defined) and (kubernetes_rke2_cni |length != 0) %}
cni: {{ kubernetes_rke2_cni }}
{% endif %}
{% if kubernetes_rke2_enable_monitoring %}
{% if kubernetes_version is defined and kubernetes_version is version('1.20', '>=') %}
kube-controller-manager-arg:
  - "bind-address=0.0.0.0"
kube-scheduler-arg:
  - "bind-address=0.0.0.0"
# Don't work with older versions (https://github.com/rancher/rke2/issues/1100)
kube-proxy-arg:
  - "metrics-bind-address=0.0.0.0:10249"
etcd-expose-metrics: true
{% else %}
kube-controller-manager-arg: "address=0.0.0.0"
kube-controller-manager-arg: "bind-address=0.0.0.0"
kube-scheduler-arg: "address=0.0.0.0"
kube-scheduler-arg: "bind-address=0.0.0.0"
{% endif %}
{% endif %}
{% if kubernetes_rke2_docker_registry %}
system-default-registry: "{{ kubernetes_rke2_docker_registry }}"
{% endif %}
tls-san:
{% for san in tls_san_list %}
  - {{ san }}
{% endfor %}
{% if (groups[kubernetes_rke2_worker_group] is defined) and ( groups[kubernetes_rke2_worker_group] | length >= 1) and (groups[kubernetes_rke2_control_group] != groups[kubernetes_rke2_worker_group]) %}
# Disallow workload on control node when we have at least one agent node
node-taint:
  - "CriticalAddonsOnly=true:NoExecute"
{% endif %}
{% if kubernetes_rke2_disable_nginx %}
disable: rke2-ingress-nginx
{% endif %}
{% if kubernetes_oidc_issuer_url is defined %}
kube-apiserver-arg:
  - "oidc-issuer-url={{ kubernetes_oidc_issuer_url }}"
  - "oidc-client-id={{ kubernetes_oidc_client_id }}"
  - "oidc-username-claim=email"
  - "oidc-groups-claim=groups"
{% endif %}
{% if kubernetes_rke2_cluster_cidr is defined %}
cluster-cidr: "{{ kubernetes_rke2_cluster_cidr }}"
{% endif %}
{% if kubernetes_rke2_service_cidr is defined %}
service-cidr: "{{ kubernetes_rke2_service_cidr }}"
{% endif %}
{% if kubernetes_rke2_node_taint_groups is defined %}
{% if inventory_hostname in groups[kubernetes_rke2_node_taint_all_hosts] %}
node-taint:
{% for taint_group in kubernetes_rke2_node_taint_groups %}
{% if inventory_hostname in groups[taint_group] %}
  - {{ kubernetes_rke2_node_taints[taint_group]}}
{% endif %}
{% endfor %}
{% endif %}
{% endif %}
